%global _use_internal_dependency_generator 0

%global momorel 2
%global iptables_ver	0.91.1
%global turtle_ver	1.27

Summary: A web-based administration interface for Unix systems.
Name: webmin
Version: 1.150
Release: %{momorel}m
Provides: %{name}-%{version}
Requires: bash perl
License: BSD
Group: System Environment/Daemons
Source: http://unc.dl.sourceforge.net/sourceforge/webadmin/webmin-%{version}.tar.gz
NoSource: 0
Source1: http://www.niemueller.de/webmin/modules/iptables/iptables-%{iptables_ver}.wbm.gz
Source2: http://twtelecom.dl.sourceforge.net/sourceforge/turtlefirewall/turtlefirewall-%{turtle_ver}.wbm.gz
Source3: webmin.sh
Patch0: webmin_init.patch
URL: http://www.webmin.com/
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Requires: momonga-release, perl-XML-Parser

%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems and more using your
web browser.

After installation, enter the URL http://localhost:10000/ into your
browser and login as root with your root password.

%prep
%setup -q -a 1 -a 2
%patch0 -p1

%build
find . -type f | xargs grep "#!/usr/local/bin" | cut -d: -f 1 | xargs perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|g;"
#(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
for i in $( ls ); do
	if [ -r $i/config-redhat-linux ]; then
	cp $i/config-redhat-linux $i/config-momonga-linux; 
	fi
done
perl -pi -e "s,redhat-linux,redhat-linux momonga-linux," */module.info
rm -f mount/freebsd-mounts-*
rm -f mount/openbsd-mounts-*
#chmod -R og-rxw .

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/usr/libexec/webmin
mkdir -p %{buildroot}/etc/sysconfig/daemons
mkdir -p %{buildroot}%{_initscriptdir}
mkdir -p %{buildroot}/etc/pam.d
cp -rp * %{buildroot}/usr/libexec/webmin
cp webmin-daemon %{buildroot}/etc/sysconfig/daemons/webmin
cp webmin-init %{buildroot}%{_initscriptdir}/webmin
cp webmin-pam %{buildroot}/etc/pam.d/webmin
echo rpm >%{buildroot}/usr/libexec/webmin/install-type
mkdir -p %{buildroot}/etc/sysconfig/firsttime
install -m 755 %{SOURCE3} %{buildroot}/etc/sysconfig/firsttime

# No Caldera and Gentoo.
rm -rf %{buildroot}/usr/libexec/webmin/*caldera*
rm -rf %{buildroot}/usr/libexec/webmin/*gentoo*

%clean
rm -rf %{buildroot}

%files
%defattr (-,root,root)
/etc/sysconfig/firsttime/webmin.sh
/usr/libexec/webmin
%{_initscriptdir}/webmin
/etc/sysconfig/daemons/webmin
%config /etc/pam.d/webmin


%pre
grep -i openlinux /etc/.issue >/dev/null 2>&1
if [ -r /etc/webmin/config -a -r /var/log/webmin -a "$1" = 0 ]; then
        oldrpm=`rpm -q webmin 2>/dev/null`
        if [ "$oldrpm" != "" ]; then
                echo "The Caldera version of Webmin is currently installed on"
                echo "your system. You must remove it with the command"
                echo "   rpm -e webmin"
                echo "before installing this Webmin RPM."
                exit 1
        fi
fi

perl <<EOD;
# maketemp.pl
# Create the /tmp/.webmin directory if needed

\$tmp_dir = "/tmp/.webmin";

if (!-d \$tmp_dir) {
        mkdir(\$tmp_dir, 0755) || exit 1;
        }
chown(\$<, \$(, \$tmp_dir);
chmod(0755, \$tmp_dir);
@st = lstat(\$tmp_dir);
if (@st && \$st[4] == \$< && (-d _) &&
    (\$st[2] & 0777) == 0755) {
        exit 0;
        }
else {
        exit 1;
        }


EOD
if [ "$?" != "0" ]; then
        echo "Failed to create or check temp files directory /tmp/.webmin"
        exit 1
fi
perl >/tmp/.webmin/$$.check <<EOD;
if (-r "/etc/.issue") {
        \$etc_issue = \`cat /etc/.issue\`;
        }
elsif (-r "/etc/issue") {
        \$etc_issue = \`cat /etc/issue\`;
        }
\$uname = \`uname -a\`;
if (-r "/etc/momonga-release") {
	\$etc_issue = \`cat /etc/momonga-release\`;
	}
\$uname = \`uname -a\`;
if (\$etc_issue =~ /Momonga\\s+Linux/i) {
	print "oscheck='Momonga Linux cvs'\\n";
	}

EOD
. /tmp/.webmin/$$.check
rm -f /tmp/.webmin/$$.check
if [ ! -r /etc/webmin/config ]; then
        if [ "$oscheck" = "" ]; then
                echo Unable to identify operating system
                exit 2
        fi
        echo Operating system is $oscheck
        if [ "$WEBMIN_PORT" != "" ]; then
                port=$WEBMIN_PORT
        else
                port=10000
        fi
        perl -e 'use Socket; socket(FOO, PF_INET, SOCK_STREAM, getprotobyname("tcp")); setsockopt(FOO, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)); bind(FOO, pack_sockaddr_in($ARGV[0], INADDR_ANY)) || exit(1); exit(0);' $port
        if [ "$?" != "0" ]; then
                echo Port $port is already in use
                exit 2
        fi
fi
# rewrite os_type
if [ "$oscheck" == "Momonga Linux cvs" ]; then
  if [ -r /etc/webmin/config ] && grep -q redhat-linux /etc/webmin/config; then
    perl -p -i -e "s,os_type=.*,os_type=momonga-linux," /etc/webmin/config
  fi
fi


%post
/sbin/chkconfig --add webmin
inetd=`grep "^inetd=" /etc/webmin/miniserv.conf 2>/dev/null | sed -e 's/inetd=//g'`
if [ "$1" != 1 ]; then
        # Upgrading the RPM, so stop the old webmin properly
        if [ "$inetd" != "1" ]; then
                %{_initscriptdir}/webmin stop >/dev/null 2>&1
        fi
fi
cd /usr/libexec/webmin
config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=3
if [ "$WEBMIN_PORT" != "" ]; then
        port=$WEBMIN_PORT
else
        port=10000
fi
login=root
if [ -r /etc/shadow ]; then
        #crypt=`grep "^root:" /etc/shadow | cut -f 2 -d :`
        crypt=x
else
        crypt=`grep "^root:" /etc/passwd | cut -f 2 -d :`
fi
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
export config_dir var_dir perl autoos port login crypt host ssl nochown autothird noperlpath nouninstall nostart allow
./setup.sh >/tmp/.webmin/webmin-setup.out 2>&1
rm -f /var/lock/subsys/webmin
if [ "" != "1" ]; then
        %{_initscriptdir}/webmin start >/dev/null 2>&1 </dev/null
fi
cat >/etc/webmin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Webmin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
        echo "Removing webmin RPM .."
        rpm -e --nodeps webmin
        echo "Done!"
fi
EOFF
chmod +x /etc/webmin/uninstall.sh
perl -e 'use Net::SSLeay' >/dev/null 2>/dev/null
if [ "$?" = "0" ]; then
        echo "Webmin install complete. You can now login to https://$host:$port/"
else
        echo "Webmin install complete. You can now login to http://$host:$port/"
fi
echo "as root with your root password."

%preun
if [ "$1" = 0 ]; then
        grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
        if [ "$?" = 0 ]; then
                # RPM is being removed, and no new version of webmin
                # has taken it's place. Run uninstalls and stop the server
                echo "Running uninstall scripts .."
                (cd /usr/libexec/webmin ; WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin LANG= /usr/libexec/webmin/run-uninstalls.pl)
                %{_initscriptdir}/webmin stop >/dev/null 2>&1
                /bin/true
        fi
        /sbin/chkconfig --del webmin
fi

%postun
if [ "$1" = 0 ]; then
        grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
        if [ "$?" = 0 ]; then
                # RPM is being removed, and no new version of webmin
                # has taken it's place. Delete the config files
                rm -rf /etc/webmin /var/webmin
        fi
fi

%changelog
* Sun Jul  4 2004 Ryu SASAOKA <ryu@momonga-linux.org>
- (1.150-2m)
- stop daemon

* Sat Jun  5 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.150-1m)
- update to 1.150

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (1.130-3m)
- use {_initscriptdir} instead of /etc/init.d.

* Sun Apr 25 2004 Toru Hoshina <t@momonga-linux.org>
- (1.130-2m)
- _use_internal_dependency_generator is setted as 0 otherwise perl(-r))...
- Caldera and Gentoo files are not necessary.

* Sat Feb 28 2004 kourin <kourin@fh.freeserve.ne.jp>
- (1.130-1m)
- up to 1.130
- remove webmin-momonga.patch (do in %%build) 

* Thu Dec 25 2003 kourin <kourin@fh.freeserve.ne.jp>
- (1.121-1m)
- up to 1.121

* Tue Nov  4 2003 zunda <zunda at freeshell.org>
- (1.090-5m)
- unecessary space removed from %%preun section

* Wed Jul 2 2003 kourin <kourin@fh.freeserve.ne.jp>
- (1.090-4m)
- add useradmin/momonga-lib.pl (wasureteta)

* Wed Jul 2 2003 kourin <kourin@fh.freeserve.ne.jp>
- (1.090-3m)
- add turtlefirewall

* Mon Jun 30 2003 kourin <kourin@fh.freeserve.ne.jp>
- (1.090-2m)
- add at/config-momonga-linux

* Mon Jun 30 2003 kourin <kourin@fh.freeserve.ne.jp>
- (1.090-1m)
- up to 1.090

* Fri Nov 22 2002 Kazuhiko <kazuhiko@fdiary.net>
- (0.990-2m)
- never requires perl-base

* Tue Jul 25 2002 smbd <smbd@momonga-linux.org>
- (0.990-1m)
- up to 0.990

* Thu Jun 27 2002 Shingo Akagaki <dora@kitty.dnsalias.org>
- (0.970-4k)
- momonga-release

* Tue May 14 2002 Toru Hoshina <t@kondara.org>
- (0.970-2k)
- ver up.
- security fix. See jitterbug/#1057.

* Fri Mar 22 2002 Tsutomu Yasuda <tom@kondara.org>
- (0.93-2k)
- update to 0.93

* Fri Jan 24 2002 Motonobu Ichimura <famao@kondara.org>
- (0.92-2k)
- up to 0.92

* Tue Dec 11 2001 Tsutomu Yasuda <tom@digitalfactory.co.jp>
- (0.90-12k)
  change for firsttime.
  disable chkconfig --add

* Tue Dec 11 2001 Motonobu Ichimura <famao@kondara.org>
- (0.90-10k)
- use our own init script

* Mon Dec  3 2001 Toru Hoshina <t@kondara.org>
- (0.90-8k)
- dont't start webmin at post scrtipts. it's not needed.

* Fri Nov 30 2001 Toru Hoshina <t@kondara.org>
- (0.90-6k)
- dont't need to check another system :-p

* Wed Nov 28 2001 Toru Hoshina <t@kondara.org>
- (0.90-4k)
- applied miniserv.diff.

* Mon Nov 05 2001 Motonobu Ichimura <famao@kondara.org>
- (0.90-2k)
- up to 0.90
- add heartbeat,cluster module

* Mon Oct 29 2001 Motonobu Ichimura <famao@kondara.org>
- (0.89-2k)
- up to 0.89

* Tue Oct 23 2001 Motonobu Ichimura <famao@kondara.org>
- (0.88-20k)
- add support for 2.1 (Asumi)

* Thu Oct 04 2001 Motonobu Ichimura <famao@kondara.org>
- (0.88-18k)
- add one line per msg patch

* Thu Oct 04 2001 Motonobu Ichimura <famao@kondara.org>
- (0.88-16k)
- a little bug fix

* Wed Oct 03 2001 Motonobu Ichimura <famao@kondara.org>
- (0.88-15k)
- add patch for <IfDefine> Directive

* Thu Oct 02 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.88-12k)
- add iptables module

* Thu Sep 27 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.88-6k)
- agaist SSL (See http://www.webmin.com/webmin/ssl.html)

* Thu Sep 27 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.88-4k)
- made new config-kondara-linux files (webmin-0.88-kondara.patch)
- add kondara-linux entry in each modules.info 
- obsoletes webmin-kondara.patch
- rewrite /etc/webmin/config (T_T)

* Wed Sep 26 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.88-2k)
- update to 0.88

* Mon Sep 10 2001 Tsutomu Yasuda <tom@digitalfactory.co.jp>
- Change Group

* Sat Jun 23 2001 Motonobu Ichimura <famao@kondara.org>
- (0.86-2k)
- first release
